using System;
using System.Collections.Generic;
using System.Linq;
using AvaloniaApplicationBase.Models;
using ReactiveUI;

namespace AvaloniaApplicationBase.ViewModels
{
    public class AddCatPageViewModel : ReactiveObject
    {
        string name = "";
        DateTime date = DateTime.Now;
        int gender = -1;
        List<string> selectedTraitsCat = new List<string>();


        public string Name { get => name; set => name = value; }
        public string Date { get => date.ToString(); set => date = DateTime.Parse(value); }
        public int Gender { get => gender; set => gender = value; }
        public List<string> AllTraits => MainWindowViewModel.myConnection.TraitTables.Select(x => x.Trait).ToList();

        public List<string> SelectedTraitsCat 
        { 
            get => selectedTraitsCat; 
            set => this.RaiseAndSetIfChanged(ref selectedTraitsCat,value); 
        }

        public string SelectedTrait
        {
            get => null;
            set
            {
                selectedTraitsCat.Add(value);
                SelectedTraitsCat = new List<string>(selectedTraitsCat);
            }
        }
        public void AddNewCat()
        {
            CatTable newCat = new CatTable()
            {
                Name = name,
                Date = date,
                Gender = gender + 1,
            };
            MainWindowViewModel.myConnection.Add(newCat);
            MainWindowViewModel.myConnection.SaveChanges();

            foreach (string item in selectedTraitsCat)
            {
                TraitTable tt = MainWindowViewModel.myConnection.TraitTables.FirstOrDefault(x => x.Trait == item);
                if (tt!=null)
                {
                TraitCatTable TCT = new TraitCatTable()
                {
                    IdCat = newCat.Id,
                    IdTrait = tt.Id
                };
                MainWindowViewModel.myConnection.TraitCatTables.Add(TCT);
                }
                
            }
            MainWindowViewModel.myConnection.SaveChanges();
        }
    }
}