﻿using Avalonia.Controls;
using AvaloniaApplicationBase.Models;
using AvaloniaApplicationBase.Views;
using Microsoft.EntityFrameworkCore;
using ReactiveUI;
using System.Collections.Generic;
using System.Linq;

namespace AvaloniaApplicationBase.ViewModels
{
    public class MainWindowViewModel : ViewModelBase
    {
        public static CatBaseContext myConnection = new CatBaseContext(); // для подключения БД

        UserControl us = new ShowCatsPage(); // сюда помещаются страницы (по умолчанию будет показана страница с просмотром информации)
        
        // свойство для изменения страниц
        public UserControl US 
        { 
            get => us; 
            set => this.RaiseAndSetIfChanged(ref us, value); 
        }

        ShowCatsPageViewModel showCatsVM = new ShowCatsPageViewModel(); // объект VM с кодом для просмотром информации о котах
        
        // свойсво для изменения выше созданной переменной
        public ShowCatsPageViewModel ShowCatsVM 
        { 
            get => showCatsVM; 
            set => showCatsVM = value; 
        }
        public AddCatPageViewModel AddCat { get => addCat; set => addCat = value; }

        AddCatPageViewModel addCat = new AddCatPageViewModel();

        public void ShowAddCatPage()
        {
            US = new AddCatPage();
        }

        public void deleteCat(int IdCat) // для удаления объекта из шаблона
        {
            CatTable catDelete = myConnection.CatTables.First(x=>x.Id == IdCat); // находим удаляемого кота в базе данных
            myConnection.CatTables.Remove(catDelete); // удаляем кота
            myConnection.SaveChanges(); // сохраняем изменения
            US = new ShowCatsPage(); // обновляем страницу для отображения актуального списка
        }
    }
}